<template>
  <div>
    <v-card outlined flat elevation="0" class="mt-5 mb-5">
      <v-container fluid>
        <v-row class="pl-5 pr-5" justify="space-between">
          <v-card-title>
            <small>Kontaktet</small>
            <f-action-btn
              icon="mdi-plus"
              @click="createClientContactModal = true"
            />
          </v-card-title>
          <v-spacer />
          <v-col sm="3">
            <search-input v-model="search" />
          </v-col>
        </v-row>
      </v-container>
      <v-data-table
        dense
        :headers="header"
        :items="contacts"
        outlined
        :footer-props="{
          'items-per-page-options': [5, 10, 15],
        }"
      >
        <template v-slot:item="row">
          <tr>
            <td>{{ row.index + 1 }}</td>
            <td>{{ row.item.name }}</td>
            <td>{{ row.item.phone_number }}</td>
            <td>{{ row.item.email }}</td>
            <td>{{ row.item.job_position }}</td>
            <td>
              <f-edit-btn @click="editContact(row.item, row.index)" />
              <f-delete-btn @click="deleteContact(row.index)" />
            </td>
          </tr>
        </template>
      </v-data-table>
    </v-card>
    <create-client-contact v-model="createClientContactModal" />
    <edit-client-contact
      v-model="editClientContactModal"
      :contact="currentContact"
    />
  </div>
</template>
<script lang="ts">
import Vue from 'vue'
import eventBus from '../../../plugins/event-bus'
import Table from '../../../plugins/table'
import { Component, Prop, Mixins } from 'vue-property-decorator'
import CreateClientContact from './Contact/CreateClientContact.vue'
import EditClientContact from './Contact/EditClientContact.vue'
import FEditBtn from '../../../components/buttons/FEditBtn.vue'
import FActionBtn from '../../../components/buttons/FActionBtn.vue'
import FDeleteBtn from '../../../components/buttons/FDeleteBtn.vue'
import SearchInput from '../../../components/inputs/SearchInput.vue'

const dataTableHeader = [
  { text: 'Id', value: 'id', sortable: false, class: 'grey lighten-4' },
  { text: 'Emri', value: 'name', sortable: false, class: 'grey lighten-4' },
  {
    text: 'Telefon',
    value: 'mobile_phone',
    sortable: false,
    class: 'grey lighten-4',
  },
  { text: 'Email', value: 'email', sortable: false, class: 'grey lighten-4' },
  {
    text: 'Pozicioni i punës',
    value: 'job_position',
    sortable: false,
    class: 'grey lighten-4',
  },
  {
    text: 'Veprime',
    value: 'actions',
    sortable: false,
    class: 'grey lighten-4',
  },
]
@Component({
  components: {
    EditClientContact,
    FActionBtn,
    FDeleteBtn,
    FEditBtn,
    SearchInput,
    CreateClientContact,
  },
})
export default class ClientContacts extends Mixins(Table) {
  @Prop({ type: Number, default: 1 }) clientId
  @Prop({ type: Array }) clientContacts
  @Prop({ required: true, default: () => [] }) value

  name = null
  phone_number = null
  email = null
  job_position = null
  search = ''
  currentContact = null
  currentContactId = 1
  header = dataTableHeader
  createClientContactModal = false
  editClientContactModal = false
  get contacts() {
    return this.value
  }
  set contacts(newValue) {
    this.$emit('input', newValue)
  }
  mounted() {
    eventBus.$on('add-contact', newValue => {
      this.name = newValue.name
      this.phone_number = newValue.phone_number
      this.email = newValue.email
      this.job_position = newValue.job_position

      this.contacts.push({
        id: this.currentContactId++,
        name: this.name,
        phone_number: this.phone_number,
        email: this.email,
        job_position: this.job_position,
      })
    })
    eventBus.$on('edit-contact', editedValue => {
      this.contacts
        .filter(contacts => contacts.id === editedValue.id)
        .map(el => {
          el.id = editedValue.id
          el.name = editedValue.name
          el.phone_number = editedValue.phone_number
          el.email = editedValue.email
          el.job_position = editedValue.job_position
        })
    })
    this.clearInputs()
    if (this.clientContacts) {
      this.contacts = this.clientContacts
    }
  }
  clearInputs() {
    eventBus.$on('clear-inputs', () => {
      this.contacts = []
    })
  }
  deleteContact(index) {
    this.contacts.splice(index, 1)
    eventBus.$emit('delete-contact', index)
  }
  editContact(contact, contact_id) {
    this.editClientContactModal = true
    this.currentContact = contact
    this.currentContactId = contact_id
  }
}
</script>

<style scoped>
.action-btn {
  margin: 7px 7px;
}
</style>
